--
-- baleExtension
-- 
-- 
--
-- upsideDown project start: 15.12.2014
-- V0.9: 18.12.2014



local fileName = g_currentModDirectory.."bales/roundbaleGrass_w112_d130.i3d";
local modDir = g_currentModDirectory;
print("BaleExtension V2.2 (by upsidedown) registering "..fileName)

BaleUtil.registerBaleType(fileName,"grass_windrow",1.12,2.4,0.9,1.3,true)
local fileNameSilage = g_currentModDirectory.."bales/roundbaleSilage_w112_d130.i3d";
local fileNameWrappedHay = g_currentModDirectory.."bales/roundbaleHayWrapped_w112_d130.i3d";
Bale.MAX_FERMENTING_TIME = 3600*24*2;


local oldloadSharedI3DFile = Utils.loadSharedI3DFile;
function Utils.loadSharedI3DFile(filename, baseDir, ...)
	
	local pos = string.find(filename,':/',1);
	if pos ~= nil then --we have a full path already!		
		baseDir = "";
	end;
	
	pos = string.find(filename,':/',3);
	
	if pos ~= nil then --we have a double path in filename... :(			
		filename = string.sub(filename,pos-1)
	end;
	
	pos = string.find(filename,'mods//ZZZ_baleExtension/bales/')
	if pos ~= nil then
		if not fileExists(Utils.getNoNil(baseDir,"")..filename) then
			-- print("BaleExtension Check "..Utils.getNoNil(baseDir,"")..filename)
			baseDir = "";
			filename = modDir..string.sub(filename,pos+24);
			-- print("suggested solution: "..filename)
		end;
	end;
	
	local id = oldloadSharedI3DFile(filename, baseDir, ...);
	if id == 0 then
		 -- print("ERROR CAUGHT!")
		-- print("A "..baseDir)
	-- print("B "..filename)
	-- print("C "..Utils.getNoNil(baseDir,"")..filename)
	
	--  receives wrong path from network sync: this is the full path of the server, crashes on the client of course: 'D:/home/sid_11202/farmingSim_2015/profile/mods//ZZZ_baleExtension/bales/roundbaleGrass_w112_d130.i3d' 
	
	
	end;
	return id
end;



local oldBaleDelete = Bale.delete;
function Bale:delete()
	g_currentMission.lastDeletedBaleHumidity = self.humidity;
	oldBaleDelete(self)
end;

local oldBaleSetNodeId = Bale.setNodeId
function Bale:setNodeId(nodeId)
	
	oldBaleSetNodeId(self,nodeId);
	self.fermentingTime = -1;
	if self.fillType == Fillable.FILLTYPE_SILAGE then
		self.humidity = g_currentMission.lastDeletedBaleHumidity;
		self.fermentingTime = 0;
	end;
	
end;


local oldWrapperLoad = BaleWrapper.load;
function BaleWrapper:load(xmlFile)
	oldWrapperLoad(self,xmlFile);
	if self.allowedBaleTypes ~= nil then
		if self.allowedBaleTypes[Fillable.FILLTYPE_GRASS_WINDROW] ~= nil then
			if self.allowedBaleTypes[Fillable.FILLTYPE_GRASS_WINDROW][1].wrapperBaleFilename == 'data/maps/models/objects/roundbales/roundbaleSilage_w112_d130.i3d' then
				self.allowedBaleTypes[Fillable.FILLTYPE_GRASS_WINDROW][1].wrapperBaleFilename = fileNameSilage;
				self.allowedBaleTypes[Fillable.FILLTYPE_DRYGRASS_WINDROW][1].wrapperBaleFilename = fileNameWrappedHay;
				-- self.allowedBaleTypes[Fillable.FILLTYPE_DRYGRASS_WINDROW] = nil; -- really a good idea?! Nope, people tell me otherwise..
			end;
		end;
	end;
end;


local oldBalerLoad = Baler.load;
function Baler:load(xmlFile)
	oldBalerLoad(self,xmlFile);	
	if self.fillTypes[Fillable.FILLTYPE_DRYGRASS_WINDROW] then
		-- print("baler has drygrass windrow, installing grass windrow for new bales")
		table.insert(self.balerPickupFillTypes,Fillable.FILLTYPE_GRASS_WINDROW);
		self.fillTypes[Fillable.FILLTYPE_GRASS_WINDROW] = true;
	end;
end;

local oldBaleUpdate = Bale.update;
function Bale:update(dt)
	oldBaleUpdate(self,dt);
	
	if self.checkDistanceAndViewCnt == nil then
		self.checkDistanceAndViewCnt = 1000*math.random();
		self.checkDistanceAndViewCntMax = self.checkDistanceAndViewCnt;
	end;
	self.checkDistanceAndViewCnt = math.max(self.checkDistanceAndViewCnt - dt,0);
	
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil then
			if g_currentMission.controlPlayer and g_currentMission.player ~= nil then	
				if g_currentMission.controlledVehicle == nil and self.checkDistanceAndViewCnt == 0 then
					
					local px,py,pz = getWorldTranslation(g_currentMission.player.rootNode);
					local bx,by,bz = getWorldTranslation(self.nodeId);
					
					local dist2 = (px-bx)^2 + (pz-bz)^2;

					if dist2 < 20 then
						self.checkDistanceAndViewCnt = 0;
					elseif dist2 < 200 then
						self.checkDistanceAndViewCnt = self.checkDistanceAndViewCntMax;
					elseif dist2 < 600 then
						self.checkDistanceAndViewCnt = 2000 + self.checkDistanceAndViewCntMax;
					else
						self.checkDistanceAndViewCnt = 5000 + self.checkDistanceAndViewCntMax;
					end;
					
					
					if dist2 < 10 then
						-- print(dist2)
						local sx,sy,_ = project(bx,by,bz);
						if math.abs(sx-0.5) < 0.3 and math.abs(sy-0.5) < 0.3 then
							-- renderText(sx,sy,0.03,"DummyString for FeedBales")
							local desc = Fillable.fillTypeIndexToDesc[self.fillType]
							
							--> bold, center
							-- setTextColor(0.0,0.0,.0,1)
							setTextAlignment(RenderText.ALIGN_CENTER); 
							setTextBold(true);
							
							setTextColor(.8,.8,.8,.9);
							if self.wrappingState > 0.2 then
								local color = 0.01;
								if not g_currentMission.environment.isSunOn then
									color = 0.6;
								end;
								setTextColor(color,color,color,.9);
							end;

							local str = desc.nameI18N.."\n"..g_i18n:getText("BaleExHumidity")..": "..string.format("%2.1f",self.humidity*100)..'%%\n';
							str = str..g_i18n:getText("BaleExFillLevel")..": "..string.format("%d",self.fillLevel)..'\n'
							if self.fermentingTime ~= nil and self.fermentingTime > 0 and self.fermentingTime < 1 then
								str = str .. g_i18n:getText("BaleExFermenting")..': '..string.format("%2.1f",self.fermentingTime*100)..'%%\n'
							end;
							
							local value, HK = self:getValue();
							local difficultyMultiplier = 2 ^ (3 - g_currentMission.missionStats.difficulty);
							local value = value * difficultyMultiplier;
							
							str = str .. g_i18n:getText("BaleExPriceClass")..': '..HK.." "..g_i18n:formatMoney(value)
							
							-- string.format("%2.1f",self.fermentingTime*100)..'%%'
							
							renderText(sx,sy-0.05,0.03,string.format(str))
							setTextAlignment(RenderText.ALIGN_LEFT); 
							setTextBold(false);
							setTextColor(.8,.8,.8,.9);
							
						end;
					end;
					
				end;
			end;
		end;
	end;	
end;

local oldBaleValue = Bale.getValue;
function Bale:getValue()
	 -- local desc = Fillable.fillTypeIndexToDesc[self.fillType];
       -- if desc ~= nil then
           -- print(desc.pricePerLiter)		   
       -- end

	local res = oldBaleValue(self);
	
	if self.fillType == Fillable.FILLTYPE_DRYGRASS_WINDROW then --standard values for hay vs silage prices are simply absurd...
		local silagePrice = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_SILAGE].pricePerLiter;
		local hayPrice = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_DRYGRASS_WINDROW].pricePerLiter;
		if hayPrice < 0.6*silagePrice then
			res = 0.6*silagePrice*res/hayPrice;
		end;		
	end;
	
	local factor = 1.0;
	local qualityClass = 'C';
	-- if self.wrappingState > 0.2 then
	if self.fillType == Fillable.FILLTYPE_WHEAT_WINDROW or self.fillType == Fillable.FILLTYPE_DRYGRASS_WINDROW then 
		if self.humidity < 0.15 and self.fillLevel/self.fillLevelMax > 0.95 then
			factor = 1.8;
			qualityClass = 'A+';
		elseif self.humidity < 0.15 and self.fillLevel/self.fillLevelMax > 0.8 then
			factor = 1.4;
			qualityClass = 'A';
		elseif self.humidity < 0.22 and self.fillLevel/self.fillLevelMax > 0.8 then
			factor = 1.0;
			qualityClass = 'B';
		else
			factor = 0.5;
			qualityClass = 'C';
		end;
		-- if self.wrappingState > 0.2 then
			-- factor = factor*1.3;
		-- end;
	elseif self.fillType == Fillable.FILLTYPE_GRASS_WINDROW or self.fillType == Fillable.FILLTYPE_SILAGE then
		if self.wrappingState > 0.2 and (self.humidity >= 0.6 or self.humidity <= 0.8) then
			if self.fillLevel/self.fillLevelMax > 0.95 then
				factor = 1.3;
				qualityClass = 'A+'
			elseif self.fillLevel/self.fillLevelMax > 0.8 then
				factor = 1.0;
				qualityClass = 'A'
			else
				factor = 0.8;
				qualityClass = 'B'
			end;
		else
			factor = 0.2;
			qualityClass = 'C'
		end;
	-- elseif self.fillType == Fillable.FILLTYPE_SILAGE then
		
	end;
	
	if self.wrappingState > 0.2 then
		factor = factor*1.3;
	end;
	
	res = res/4;
	
	return factor*res, qualityClass
end;

local oldBaleUpdateTick = Bale.updateTick;
function Bale:updateTick(dt)
	 
	oldBaleUpdateTick(self,dt)
	
	if self.isServer then
		if self.checkCoverCounterMax == nil then
			self.checkCoverCounterMax = 2000 + 3*1000*math.random();
			self.checkCoverCounter = self.checkCoverCounterMax;
			self.rayCastDistanceOffset = 0;
			self.emptySkyCnt = 3;
		end;
		
		
		self.checkCoverCounter = self.checkCoverCounter - dt;
		if self.checkCoverCounter < 0 or g_currentMission.missionStats.timeScale > 125 or self.extensionInitDone==nil then
			
			
			self.extensionInitDone = true;
			local cntDt = (self.checkCoverCounterMax - self.checkCoverCounter)/1000; --sec passed
			if g_currentMission.missionStats.timeScale > 125 then
				cntDt = dt/1000;
				if not Utils.getNoNil(self.isFastForward,false) then
					self.isFastForward = true;
					-- print("upsi..",cntDt," ",cntDt*g_currentMission.missionStats.timeScale)
					cntDt = 0;
				end
			else
				self.isFastForward = false;
			end;
				-- print(cntDt)
				-- print(g_currentMission.missionStats.timeScale*cntDt)
				-- cntDt = math.min(cntDt,100);
			
			
			
			local x,y,z = getWorldTranslation(self.nodeId);
			self.scoredHit = false;
			raycastClosest(x, y+self.rayCastDistanceOffset, z, 0, 1, 0, "baleExtensionRaycastCallback", 20, self)
						
			if not self.scoredHit then
				self.rayCastDistanceOffset = 0;
				self.emptySkyCnt = math.max(self.emptySkyCnt - 1,0);
			end;

			if true then
				if self.humidity == nil then
					
					self.humidity = 0.13;
					if self.fillType == Fillable.FILLTYPE_GRASS_WINDROW then
						self.humidity = 0.7;
					end;
					if self.fillType == Fillable.FILLTYPE_SILAGE then
						self.humidity = 0.7;
					end;
					self.humidity = self.humidity + 0.15*math.max((240-g_currentMission.environment.timeSinceLastRain)/240,0)
				end;
				if self.dryMass == nil then					
					self.dryMass = (1-self.humidity)*getMass(self.nodeId); --gets reasonable value in tons
					self.fillLevelMax = self.fillLevel;					
				end;

				local equiHumidity = 0.1;
				if self.emptySkyCnt < 1 and g_currentMission.environment.currentRain ~= nil then
					if g_currentMission.environment.currentRain.rainTypeId == "hail" then
						equiHumidity = 0.5;
					elseif g_currentMission.environment.currentRain.rainTypeId == "rain" then
						equiHumidity = 0.45;
					elseif g_currentMission.environment.currentRain.rainTypeId == "fog" then
						equiHumidity = 0.2;
					elseif g_currentMission.environment.currentRain.rainTypeId == "cloudy" then
						equiHumidity = 0.15;
					end;					
				end;
				
				local dayT = g_currentMission.environment.weatherTemperaturesDay[1]
				local nightT = g_currentMission.environment.weatherTemperaturesNight[1]
				local dryFactor = 0.05;
				if g_currentMission.environment.isSunOn then --daytime
					dryFactor = math.max((dayT - 10)/75,0);
					if dayT < 8 then
						equiHumidity = equiHumidity + .05;
					end;
				else
					dryFactor = 0;
					if nightT < 10 then
						equiHumidity = equiHumidity + .05;
					end;
				end;
				dryFactor = dryFactor * 1.5; --general speed adjust
				
				local damageLimit = 0.5; --hay default
				local rottingFTfac = 1.0;
				local humidLimit = 0;
				if self.fillType == Fillable.FILLTYPE_WHEAT_WINDROW then 
					damageLimit = 0.8;
					rottingFTfac = 0.8;
					dryFactor = dryFactor * 1.2; --straw doesnt soak water like grass does
				elseif self.fillType == Fillable.FILLTYPE_GRASS_WINDROW then
					damageLimit = 0;
					rottingFTfac = 0.4; --this is NOT slower because of humidLimit!
					humidLimit = 1.0;
					dryFactor = 0.038;
					if self.wrappingState >= 0.5 then
						if self.humidity < 0.6 then
							damageLimit = 1 - (0.6-self.humidity)/0.6;
						elseif self.humidity > 0.8 then
							damageLimit = 1 - (self.humidity-0.8)/0.2;
						end;
					end;
				end;
				
				
				if self.wrappingState < 0.5 then --normal bales, not wrapped (yet)
					local dH = 2.5e-5*(equiHumidity-self.humidity)*cntDt*g_currentMission.missionStats.timeScale;
					if dH < 0 then
						dH = dH*dryFactor; --drying is much slower than getting wet in rain and fog..
					end;
					self.humidity = self.humidity + dH;

					local newMass = self.dryMass/(1-self.humidity);
					-- setMass(self.nodeId,newMass); -- this is NOT helpfull					
				else --wrapped bales
					if self.fillType == Fillable.FILLTYPE_SILAGE or self.fermentingTime > 0 then
						self.fermentingTime = Utils.getNoNil(self.fermentingTime,0) + cntDt*g_currentMission.missionStats.timeScale/Bale.MAX_FERMENTING_TIME;
						self.fermentingTime = math.min(self.fermentingTime,1);
						if self.fermentingTime < 1 then
							-- print(tostring(self).."  "..tostring(self.fermentingTime*100))
							self.fillType = Fillable.FILLTYPE_GRASS_WINDROW;							
						else
							self.fillType = Fillable.FILLTYPE_SILAGE;
						end;						
					end;
					if (self.fillType == Fillable.FILLTYPE_SILAGE or self.fillType == Fillable.FILLTYPE_GRASS_WINDROW) and (self.humidity < 0.6 or self.humidity > 0.8) then --this is too dry or too wet!
						local dF = 1e-5*self.fillLevel*cntDt*g_currentMission.missionStats.timeScale;
						self:setFillLevel(self.fillLevel-dF);
					end;					
				end;
				
				if self.fillType == Fillable.FILLTYPE_WHEAT_WINDROW or self.fillType == Fillable.FILLTYPE_DRYGRASS_WINDROW or (self.fillType == Fillable.FILLTYPE_GRASS_WINDROW and self.wrappingState < 0.5) then 
					if self.fillLevel > damageLimit*self.fillLevelMax then
						local rottingFac = math.max(self.humidity-0.15,humidLimit)*math.sqrt(math.max((self.fillLevel - damageLimit*self.fillLevelMax)/self.fillLevelMax,0));
						if rottingFac > 0 then
							local dF = 5e-6*rottingFTfac*rottingFac*self.fillLevel*cntDt*g_currentMission.missionStats.timeScale;
							self:setFillLevel(self.fillLevel-dF);
						end;
					end;
				end;
				
				if self.fillLevel < 0.2*self.fillLevelMax then --totally rotten..
					if self.mountObject== nil then --we dont want to do that with the bale being loaded on an autoloader etc
						--here we could load rotten bale model
						self:delete();
					end;
				end;
			end;
			if self.checkCoverCounter < 0 then
				BaleSyncEvent.sendEvent(self)
				self.checkCoverCounter = self.checkCoverCounterMax;
			end;
		end;
	end;
end;



function Bale:baleExtensionRaycastCallback(hitObjectId, x, y, z, distance)
	self.scoredHit = true;
	if hitObjectId == self.nodeId then
		self.rayCastDistanceOffset = self.rayCastDistanceOffset + distance+0.001;
	else
		self.rayCastDistanceOffset = 0;
		self.emptySkyCnt = 3;
	end;
end


local oldBaleSave = Bale.getSaveAttributesAndNodes;
function Bale.getSaveAttributesAndNodes(self,nodeIdent)
	local attributes, nodes = oldBaleSave(self,nodeIdent);	
	attributes = attributes .. ' humidity="' .. Utils.getNoNil(self.humidity,0.15) 
	attributes = attributes .. '" dryMass ="' .. Utils.getNoNil(self.dryMass,400) 
	attributes = attributes .. '" fillLevelMax ="' .. Utils.getNoNil(self.fillLevelMax,self.fillLevel) 
	attributes = attributes .. '" fermentingTime ="' .. Utils.getNoNil(self.fermentingTime,-1) 
	
	attributes = attributes .. '"';

	return attributes, nodes
end;

local oldBaleLoad = Bale.loadFromAttributesAndNodes
function Bale:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local res = oldBaleLoad(self,xmlFile, key, resetVehicles)
	

	self.humidity = getXMLFloat(xmlFile, key.."#humidity");
	self.dryMass = getXMLFloat(xmlFile, key.."#dryMass");
	self.fillLevelMax = getXMLFloat(xmlFile, key.."#fillLevelMax");
	self.fermentingTime = getXMLFloat(xmlFile, key.."#fermentingTime");
	
	return res;
end;






BaleSyncEvent = {};
BaleSyncEvent_mt = Class(BaleSyncEvent, Event);

InitEventClass(BaleSyncEvent, "BaleSyncEvent");

function BaleSyncEvent:emptyNew()
    local self = Event:new(BaleSyncEvent_mt);
    self.className="BaleSyncEvent";
    return self;
end;

function BaleSyncEvent:new(bale)
    local self = BaleSyncEvent:emptyNew()
    self.bale = bale;
	self.humidity = bale.humidity;
	self.dryMass = bale.dryMass;
	self.fillLevel = bale.fillLevel;
	self.fillLevelMax = bale.fillLevelMax;
	self.fermentingTime = bale.fermentingTime;
	self.fillType = bale.fillType;
    return self;
end;

function BaleSyncEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.bale));
	streamWriteFloat32(streamId, self.humidity);
	streamWriteFloat32(streamId, self.dryMass);
	streamWriteFloat32(streamId, self.fillLevel);
	streamWriteFloat32(streamId, self.fillLevelMax);
	streamWriteFloat32(streamId, self.fermentingTime);
	streamWriteUIntN(streamId, self.fillType, Fillable.sendNumBits);	
	--print("server side event is sending stuff")
end;

function BaleSyncEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.bale = networkGetObject(id);
	
	self.bale.humidity = streamReadFloat32(streamId);
	self.bale.dryMass = streamReadFloat32(streamId);
	self.bale.fillLevel = streamReadFloat32(streamId);
	self.bale.fillLevelMax = streamReadFloat32(streamId);
	self.bale.fermentingTime = streamReadFloat32(streamId);	
    self.bale.fillType = streamReadUIntN(streamId, Fillable.sendNumBits);
end;

function BaleSyncEvent.sendEvent(bale)
	if g_server ~= nil then
		g_server:broadcastEvent(BaleSyncEvent:new(bale), nil, nil, bale);	
	end;
end;